namespace :populator do
  desc 'populate db'
  task learning_object: :environment do
    @date = DateTime.strptime('05-10-2016', '%d-%m-%Y')
    [5_000, 10_000].each { |i| populate(i) }
  end

  task print_score: :environment do
    dbs = %w(
      20161010170343_portalmec_120_users_only
      20161010182216_portalmec_500_users_only
      20161010204837_portalmec_1000_users_only
    )
    dbs.each do |name|
      Rake::Task['db:restore'].reenable
      Rake::Task['db:restore'].invoke(nil, name)
      Rake::Task['searchkick:reindex:all'].reenable
      Rake::Task['searchkick:reindex:all'].invoke

      Rake::Task['search:learning_objects'].reenable
      Rake::Task['search:learning_objects'].invoke(name)
    end
  end

  private

  def populate(user_count)
    Rake::Task['db:restore'].reenable
    Rake::Task['db:restore'].invoke(nil, 'back')
    Populator.populate user_count: user_count, date: @date

    # LearningObject.find_each { |lo| LearningObject.reset_counters(lo.id, :views, :likes, :downloads, :shares) }
    progressbar = ProgressBar.create(title: 'reset counters from learning objects', total: LearningObject.count)
    Parallel.each(LearningObject.all, in_threads: 8) do |object|
      ActiveRecord::Base.connection_pool.with_connection do
        LearningObject.reset_counters(object.id, :views, :likes, :downloads, :shares)
      end
      progressbar.increment
    end

    Rake::Task['score:calculate_sync'].reenable
    Rake::Task['score:calculate_sync'].invoke('LearningObject')
    Rake::Task['score:calculate_sync'].reenable
    Rake::Task['score:calculate_sync'].invoke('User')
    Rake::Task['searchkick:reindex:all'].reenable
    Rake::Task['searchkick:reindex:all'].invoke
    Rake::Task['search:learning_objects'].reenable
    Rake::Task['search:learning_objects'].invoke("#{user_count}_users")
    Rake::Task['db:dump'].reenable
    Rake::Task['db:dump'].invoke("#{user_count}_users_only")
    sleep(5.seconds)
  end
end
